# MitoZ 3

[![install with bioconda](https://img.shields.io/badge/install%20with-bioconda-brightgreen.svg?style=flat)](http://bioconda.github.io/recipes/mitoz/README.html)  [![Anaconda-Server Badge](https://anaconda.org/bioconda/mitoz/badges/version.svg)](https://anaconda.org/bioconda/mitoz) [![Anaconda-Server Badge](https://anaconda.org/bioconda/mitoz/badges/latest_release_date.svg)](https://anaconda.org/bioconda/mitoz) [![Anaconda-Server Badge](https://img.shields.io/conda/dn/bioconda/mitoz)](https://anaconda.org/bioconda/mitoz)  [![Anaconda-Server Badge](https://anaconda.org/bioconda/mitoz/badges/license.svg)](https://anaconda.org/bioconda/mitoz)   
[![docker build](https://img.shields.io/docker/cloud/build/guanliangmeng/mitoz)](https://hub.docker.com/r/guanliangmeng/mitoz/tags) [![docker pulls](https://img.shields.io/docker/pulls/guanliangmeng/mitoz?style=flat)](https://hub.docker.com/r/guanliangmeng/mitoz/tags) [![docker latest version](https://img.shields.io/docker/v/guanliangmeng/mitoz)](https://hub.docker.com/r/guanliangmeng/mitoz/tags) [![singularity image](https://img.shields.io/badge/Singularity%20build-passing-brightgreen)](https://www.dropbox.com/sh/mqjqn656x41q2wb/AAD02t_kUCjNHbBgCeYpEM88a?dl=0) [![Conda-pack](https://img.shields.io/badge/conda--pack-passing-brightgreen)](https://github.com/linzhi2013/MitoZ/wiki/Installation#3-conda-pack)  

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.

**WHEN YOU ADAPT (PART OF) THE SOFTWARE FOR YOUR USE CASES, THE AUTHOR AND
THE SOFTWARE MUST BE EXPLICITLY CREDITED IN YOUR PUBLICATIONS AND SOFTWARE,
AND YOU SHOULD ASK THE USERS OF YOUR SOFTWARE TO CITE THE SOFTWARE IN
THEIR PUBLICATIONS. IN A WORD, 请讲武德.**

**About:**
- **MitoZ provides a "one-click" solution to get annotated mitogenomes from raw data fastq files.**

**News**
- **Distribute my working MitoZ environment using [Conda-Pack](https://github.com/linzhi2013/MitoZ/wiki/Installation#2-conda-pack) to try to avoid the missing Perl module problem. It is worth a try if you have the missing Perl module problem!**
- **Add Docker support for MitoZ (see the Installation part)**
- **Share the Singuliarty image of the latest version of MitoZ via Dropbox (see the Installation part)**
- **Added a tutorial at https://github.com/linzhi2013/MitoZ/wiki/Tutorial and explained the resulting files**
- **MitoZ 3.4 has come out (and rebuilt for the Conda version too https://github.com/linzhi2013/MitoZ/issues/151) and fixed a few bugs, it's recommended to update to this version!**


**See**
- **Installation: https://github.com/linzhi2013/MitoZ/wiki/Installation** and https://github.com/linzhi2013/MitoZ/issues/152
- **New Features: https://github.com/linzhi2013/MitoZ/wiki/New-Features**
- **Tutorial: https://github.com/linzhi2013/MitoZ/wiki/Tutorial**
- **Documentation: https://github.com/linzhi2013/MitoZ/wiki**
- **Latest release: https://github.com/linzhi2013/MitoZ/releases/**


**Bugs and Questions**
- Have a look at https://github.com/linzhi2013/MitoZ/issues and https://github.com/linzhi2013/MitoZ/wiki/Known-issues for known bugs or issues.

- **Please try the latest version first if you find some bugs in the old versions**
  - to do that, you should specify the version of MitoZ when you use the `mamba/conda` command (please refer to the [installation instruction](https://github.com/linzhi2013/MitoZ/wiki/Installation)), as I found out that many people still download the older versions.

- _I have been updating the documentation from time to time, so it may be good for you to check the documentation again every after some time._

- In case there are still bugs in the latest version, please **firstly search https://github.com/linzhi2013/MitoZ/issues** and the Wiki to check whether similar questions have been raised by other users. If no related issues and answers are found, then please raise a new issue. Thank you!

- Any feedbacks are wellcome!


# Citations
- Meng G, Li Y, Yang C, Liu S. MitoZ: a toolkit for animal mitochondrial genome assembly, annotation and visualization. Nucleic acids research. 2019 Jun 20;47(11):e63-. https://doi.org/10.1093/nar/gkz173
- See also https://github.com/linzhi2013/MitoZ/wiki/Citations
