#!/usr/bin/env python3
from setuptools import setup, find_packages

with open('README.md') as f:
    long_description = f.read()


setup(
    name='mitoz',
    version = '3.5',
    author = 'Guanliang Meng',
    author_email = 'linzhi2012@gmail.com',
    long_description = long_description,
    license = 'GPLv3',
    packages=find_packages(),
    entry_points = {'console_scripts': ['mitoz = mitoz.MitoZ:main', 'mitoz-tools = mitoz.tools:main']},
    url='https://github.com/linzhi2013/MitoZ',
    python_requires='>=3',
    install_requires = [
	    # No dependencies listed here since we need to rely on conda anyway
    ],
    include_package_data=True, # https://setuptools.pypa.io/en/latest/userguide/datafiles.html. This tells setuptools to install any data files it finds in your packages. The data files must be specified via the MANIFEST.in file.
    classifiers = [
        "Development Status :: 4 - Beta",
        "Environment :: Console",
        "Intended Audience :: Science/Research",
        "License :: OSI Approved :: GPLv3 License",
        "Natural Language :: English",
        "Programming Language :: Python :: 3.6",
        "Topic :: Scientific/Engineering :: Bio-Informatics"
    ]
)


